Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa29w.bas
'*
'* aISA-M29
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/08
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA29_DLL_NAME = "aisa29.dll"  ' DLLt@C
Global Const AISA29_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa29.dll[h
'*      Ȃ
'* ߂l   True  
'*          False s
'*****************************************************************************
Function Aisa29wDllOpen() As Boolean

    Aisa29wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(AISA29_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Aisa29wGetDllExportFunc() = False Then
        Aisa29wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Aisa29wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa29.dllA[h
'*      Ȃ
'* ߂l   True  
'*          False s
'*****************************************************************************
Function Aisa29wDllClose() As Boolean

    Aisa29wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Aisa29wDllClose = False

End Function

'*****************************************************************************
'* @\  aISA-M29̃o[Wԍ擾
'*   pdwDllVer --- DLLo[Wԍi[AhX
'*       pdwDrvVer --- DRVo[Wԍi[AhX
'* ߒl  True      --- 
'*       False     --- s
'*****************************************************************************
Function Aisa29wGetVersion(ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Boolean

    Aisa29wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Aisa29GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function

    Aisa29wGetVersion = True

End Function

'*****************************************************************************
'* @\  aISA-M29̔Cӂ̃foCX̎gp錾
'*   pwLogSlot  --- gpfoCXi[AhX
'* ߒl  True       --- 
'*       False      --- s
'*****************************************************************************
Function Aisa29wCreate(ByRef pwLogSlot As Integer) As Boolean

    Aisa29wCreate = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29Create(pwLogSlot) = 0 Then Exit Function

    Aisa29wCreate = True

End Function

'*****************************************************************************
'* @\  aISA-M29̔Cӂ̃foCX̎gpJ
'*   wLogSlot  --- gpfoCX
'* ߒl  True      --- 
'*       False     --- s
'*****************************************************************************
Function Aisa29wClose(ByVal wLogSlot As Integer) As Boolean

    Aisa29wClose = False

    If hDLL = 0 Then Exit Function

    If Aisa29Close(wLogSlot) = 0 Then Exit Function

    Aisa29wClose = True

End Function

'*****************************************************************************
'* @\  wfoCX̃\[X擾
'*   wLogSlot --- ׂfoCX
'*       pResInfo --- \[Xi[\̂̃AhX
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wGetResource(ByVal wLogSlot As Integer, ByRef pResInfo As AISA29RESOURCE) As Boolean

    Aisa29wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29GetResource(wLogSlot, pResInfo) = 0 Then Exit Function

    Aisa29wGetResource = True

End Function

'*****************************************************************************
'* @\  [hZbg
'*   wLogSlot --- ݒ肷foCX
'*       bMode    --- [h
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wModeSet(ByVal wLogSlot As Integer, ByVal bMode As Byte) As Boolean
    
    Aisa29wModeSet = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29ModeSet(wLogSlot, bMode) = 0 Then Exit Function

    Aisa29wModeSet = True

End Function

'*****************************************************************************
'* @\  C-REQ |[g֏
'*   wLogSlot --- ݂foCX
'*       wCreq    --- C-REQ `l ( AISA29_CREQ_1 ܂ AISA29_CREQ_2 )
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wCreqWrite(ByVal wLogSlot As Integer, ByVal wCreq As Integer) As Boolean

    Aisa29wCreqWrite = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29CreqWrite(wLogSlot, wCreq) = 0 Then Exit Function

    Aisa29wCreqWrite = True

End Function

'*****************************************************************************
'* @\  Xe[^Xǂݍ
'*   wLogSlot --- ǂݍ݂foCX
'*       pbStatus --- Xe[^Xi[̈ւ̃|C^
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wGetStatus(ByVal wLogSlot As Integer, ByRef pbStatus As Byte) As Boolean

    Aisa29wGetStatus = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29GetStatus(wLogSlot, pbStatus) = 0 Then Exit Function

    Aisa29wGetStatus = True

End Function

'*****************************************************************************
'* @\  f[^
'*   wLogSlot --- ݂foCX
'*       bCmd     --- R}h
'*       dwData   --- f[^
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wDataWrite(ByVal wLogSlot As Integer, ByVal bCmd As Byte, ByVal dwData As Long) As Boolean

    Aisa29wDataWrite = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29DataWrite(wLogSlot, bCmd, dwData) = 0 Then Exit Function

    Aisa29wDataWrite = True

End Function

'*****************************************************************************
'* @\  f[^ǂݍ
'*   wLogSlot --- ǂݍ݂foCX
'*       bCmd     --- R}h
'*       pdwData  --- f[^i[̈ւ̃|C^
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************
Function Aisa29wDataRead(ByVal wLogSlot As Integer, ByVal bCmd As Byte, ByRef pdwData As Long) As Boolean

    Aisa29wDataRead = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29DataRead(wLogSlot, bCmd, pdwData) = 0 Then Exit Function

    Aisa29wDataRead = True

End Function

'*****************************************************************************
'* @\  JXP[h
'*   wLogSlot --- ݂foCX
'*       dwCh1Data--- `lPɏރf[^
'*       dwCh2Data--- `lQɏރf[^
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************/
Function Aisa29wCascadeWrite(ByVal wLogSlot As Integer, ByVal dwCH1Data As Long, ByVal dwCH2Data As Long) As Boolean

    Aisa29wCascadeWrite = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29CascadeWrite(wLogSlot, dwCH1Data, dwCH2Data) = 0 Then Exit Function

    Aisa29wCascadeWrite = True

End Function

'*****************************************************************************
'* @\  JXP[hǂݍ
'*   wLogSlot --- ǂݍ݂foCX
'*       dwCh1Data--- `lPf[^i[̈ւ̃|C^
'*       dwCh2Data--- `lQf[^i[̈ւ̃|C^
'* ߒl  True     --- 
'*       False    --- s
'*****************************************************************************/
Function Aisa29wCascadeRead(ByVal wLogSlot As Integer, ByRef pdwCh1Data As Long, ByVal pdwCh2Data As Long) As Boolean

    Aisa29wCascadeRead = False
    
    If hDLL = 0 Then Exit Function

    If Aisa29CascadeRead(wLogSlot, pdwCh1Data, pdwCh2Data) = 0 Then Exit Function

    Aisa29wCascadeRead = True

End Function

'*****************************************************************************
'* @\      aISA-M29̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa29wGetLastError(ByVal wLogSlot As Integer) As Long

    Aisa29wGetLastError = AISA29_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function

    Aisa29wGetLastError = Aisa29GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa29wGetDllExportFunc() As Boolean

    Dim pFunc As Long

    Aisa29wGetDllExportFunc = False

    ' Aisa29GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29GetVersion")
    If pFunc = 0 Then Exit Function

    ' Aisa29Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29Create")
    If pFunc = 0 Then Exit Function

    ' Aisa29Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29Close")
    If pFunc = 0 Then Exit Function

    ' Aisa29GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa29ModeSet ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29ModeSet")
    If pFunc = 0 Then Exit Function

    ' Aisa29ModeSet ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29ModeSet")
    If pFunc = 0 Then Exit Function

    ' Aisa29CreqWrite ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29CreqWrite")
    If pFunc = 0 Then Exit Function

    ' Aisa29GetStatus ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29GetStatus")
    If pFunc = 0 Then Exit Function

    ' Aisa29DataWrite ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29DataWrite")
    If pFunc = 0 Then Exit Function

    ' Aisa29DataRead ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29DataRead")
    If pFunc = 0 Then Exit Function

    ' Aisa29CascadeWrite ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29CascadeWrite")
    If pFunc = 0 Then Exit Function

    ' Aisa29CascadeRead ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29CascadeRead")
    If pFunc = 0 Then Exit Function

    ' Aisa29GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa29GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa29wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
